<?php
namespace Claromentis\People;

$GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"] ?: array()) + array("_7f628626d" . "d1d55c71b1" . "fc0932ffd1" . "d2c" => base64_decode("aXNfYXJ" . "yYXk="), "_88aa4158bbda1ad77d1387" . "80ea68e38b" => base64_decode("U0VMRUNUIGlkLCBpc19w" . "cmltYXJ5IEZST00gb3Jn" . "X2NoYXJ0IFdIRVJFIGJv" . "c3NfaWQ9aW50OnVpZA=="), "_736432b3f9e1cd2ec77cd6f2ba" . "0c3bdb" => base64_decode("U0VMRUNUIGJvc3NfaWQgRlJPTSBvcmdfY2hhcnQgV0hFUkUgaWQ9aW50OnVpZCBBTkQgYm9zc19pZDw+aW50OnVpZCBPUkRFU" . "iBCWSBpc19wcmltYXJ5"), "_2f700090654ea43a4fec1f8ca5084" . "d38" => base64_decode("REVMRVRFIEZST00gb3JnX2NoYXJ0IFdIRVJFIGJvc3NfaWQ9aW50OnVp" . "ZA=="), "_e02488992f8ce86" . "b71d9f32b29fe215" . "c" => base64_decode("SU5TRVJUIElOVE8gb3JnX2NoYXJ0IChpZCwgYm9zc19pZCwgaXNfcHJpbWFyeSk" . "gVkFMVUVTIChpbnQ6dWlkLCBpbnQ6bWFuYWdlcl9pZCwgMSk="), "_62d701c3c53404f06345eb" . "35720a47b4" => base64_decode("aXNfbnVtZXJpYw" . "=="), "_98966bfaaccbeb465" . "8a87a97e8fafb11" => base64_decode("REVMRVRFIEZST00g" . "b3JnX2NoYXJ0IFdI" . "RVJFIGlkPWludDp1" . "aWQ="), "_680cc2b8220e94c8c32b8" . "bc7c65519b4" => base64_decode("aXNfaW5" . "0"));
use Claromentis\Core\DAL\Interfaces\DbInterface;







class UsersHierarchyService
{
    
    
    
    
    protected $db;
    public function __construct(DbInterface $db)
    {
        $this->db = $db;
    }
    
    
    
    
    
    
    
    
    public function SetManager($user_id, $_b324f64f5346fe6cd20483e208d94430) : bool
    {
        if (!$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_62d701c" . "3c53404f" . "06345eb3" . "5720a47b" . "4"]($user_id) || !$user_id) {
            return false;
        }
        
        
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_98966bfaaccbeb4658a87a97e8" . "fafb11"], $user_id);
        if ($_b324f64f5346fe6cd20483e208d94430 === null) {
            return true;
        }
        if (!$GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_680cc2b8220e94c8c" . "32b8bc7c65519b4"]($_b324f64f5346fe6cd20483e208d94430)) {
            return false;
        }
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_e02488992f8ce86b71d9" . "f32b29fe215c"], $user_id, $_b324f64f5346fe6cd20483e208d94430);
        return true;
    }
    
    
    
    
    
    
    
    public function SetSubordinates($user_id, $_9b25bd1f846ab3177a43069b54248349)
    {
        
        
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_2f700090654ea43a4fec1" . "f8ca5084d38"], $user_id);
        
        
        if (!$GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_7f62862" . "6dd1d55c" . "71b1fc09" . "32ffd1d2" . "c"]($_9b25bd1f846ab3177a43069b54248349)) {
            return false;
        }
        
        
        foreach ($_9b25bd1f846ab3177a43069b54248349 as $_f19d55a3cc79997bcb33f250cc2ee482) {
            if (!$this->SetManager($_f19d55a3cc79997bcb33f250cc2ee482, $user_id)) {
                return false;
            }
        }
        return true;
    }
    
    
    
    
    
    
    
    public function GetManager($user_id)
    {
        list($_b324f64f5346fe6cd20483e208d94430) = $this->db->query_row($GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_736432b3f9e1cd2ec77" . "cd6f2ba0c3bdb"], $user_id, $user_id);
        return $_b324f64f5346fe6cd20483e208d94430 ?? 0;
    }
    
    
    
    
    
    
    
    public function GetSubordinates($user_id)
    {
        $_189840d11056515e52402d1412a0b6e4 = $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_88aa4158" . "bbda1ad77" . "d138780ea" . "68e38b"], $user_id);
        $_5bbedf94f4628faff30d9e300695d342 = array();
        while ($row = $_189840d11056515e52402d1412a0b6e4->fetchRow()) {
            if (!$row[1] && self::GetManager($row[0]) != $user_id) {
                continue;
            }
            $_5bbedf94f4628faff30d9e300695d342[] = $row[0];
        }
        return $_5bbedf94f4628faff30d9e300695d342;
    }
}